package com.app.input.color.board.uiactivity

import android.annotation.SuppressLint
import android.content.Intent
import android.graphics.drawable.Drawable
import android.os.Bundle
import android.util.Log
import android.widget.FrameLayout
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.isVisible
import androidx.lifecycle.lifecycleScope
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.ad.tradpluslibrary.TPAdManager

import com.app.input.color.board.App
import com.app.input.color.board.R
import com.app.input.color.board.bean.BeanDetails
import com.app.input.color.board.callback.OnItemClickCallback
import com.app.input.color.board.callback.SetKeyboardCallback
import com.app.input.color.board.database.DatabaseManager
import com.app.input.color.board.listutils.SetKeyboardMoreAdapter
import com.app.input.color.board.uifragment.DialogEnableKeyboard
import com.app.input.color.board.utils.Common
import com.app.input.color.board.utils.DealZipFile
import com.app.input.color.board.utils.SaveCurrentTheme
import com.bumptech.glide.Glide
import com.bumptech.glide.integration.webp.decoder.WebpDrawable
import com.bumptech.glide.load.DataSource
import com.bumptech.glide.load.engine.GlideException
import com.bumptech.glide.request.RequestListener
import com.bumptech.glide.request.target.Target
import kotlinx.coroutines.launch
import java.io.File


class SetKeyboardActivity : AppCompatActivity() {
    companion object {
        @JvmField
        var DISPLAY_URL_KEY: String = "display_url_key"

        @JvmField
        val ZIP_URL_KEY = "zip_url_key"


        @JvmField
        val NAME_KEY = "name_key"

        @JvmField
        val GIF_KEY = "gif_key"

        @JvmField
        val THUMB_KEY = "thumb_key"

        @JvmField
        val SOURCE_KEY = "data_key"
    }

    private var dialog: DialogEnableKeyboard? = null
    private lateinit var displayUrl: String
    private lateinit var gifUrl: String
    private lateinit var zipUrl: String
    private lateinit var name: String
    private lateinit var applyBtn: LinearLayout
    private lateinit var imgData: ImageView
    private lateinit var imgBack: ImageView
    private lateinit var textName: TextView

    private lateinit var recommendedRecycler: RecyclerView
//    private lateinit var viewAllLayout: LinearLayout

    private lateinit var loadingLayout: FrameLayout

    private lateinit var unzipPath: String

    private lateinit var tvDownload: TextView
    private lateinit var imDownload: ImageView

    private lateinit var thumb: String

    private lateinit var imgLike: ImageView

    private lateinit var data: BeanDetails

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_set_keyboard)
        Common.initFullScreen(this,false)

        findViewId()
        getExtraData()
        displayData()
        setApply()
        onClick()
        TPAdManager.showTPAD(this@SetKeyboardActivity) {   }
    }


    private fun getExtraData() {
        data = intent.getSerializableExtra(SOURCE_KEY) as BeanDetails

        displayUrl = intent.getStringExtra(DISPLAY_URL_KEY).toString()
        zipUrl = intent.getStringExtra(ZIP_URL_KEY).toString()
        name = intent.getStringExtra(NAME_KEY).toString()
        gifUrl = intent.getStringExtra(GIF_KEY).toString()
        thumb = intent.getStringExtra(THUMB_KEY).toString()

        val serviceZipName = DealZipFile.getServiceZipName(zipUrl)
        unzipPath = DealZipFile.getUnzipPath(serviceZipName)

        Log.d("-------------------", "-------unzipPath=" + unzipPath)
        lifecycleScope.launch {
            DatabaseManager.getIsLike(name) {
                imgLike.isSelected = it
            }
        }

        if (File(unzipPath).exists()) {
            imDownload.isVisible = false
            tvDownload.text = getString(R.string.apply)
        } else {
            imDownload.isVisible = true
            tvDownload.text = getString(R.string.download_apply)
        }

    }

    private fun findViewId() {
        applyBtn = findViewById(R.id.layoutDownloadApply)
        imgData = findViewById(R.id.image_data)
        imgBack = findViewById(R.id.back)
        textName = findViewById(R.id.textview_data_name)
        recommendedRecycler = findViewById(R.id.recommended_recycler)
//        viewAllLayout = findViewById(R.id.layout_view_all)

        imgLike = findViewById(R.id.im_like)
        loadingLayout = findViewById(R.id.loading)
        imDownload = findViewById(R.id.im_download)
        tvDownload = findViewById(R.id.tv_download)
    }

    private fun displayData() {
        textName.text = name
        if (gifUrl.isNotEmpty()) {
            loadImgGif()
        } else {
            Glide.with(this)
                .load(displayUrl)
                .thumbnail(Glide.with(this).load(thumb))
                .into(imgData)
        }
    }


    private fun onClick() {
        imgBack.setOnClickListener {
                finish()
        }

        imgLike.setOnClickListener {
            imgLike.isSelected = !imgLike.isSelected

            lifecycleScope.launch {
                if (imgLike.isSelected) {
                    DatabaseManager.addLike(data)
                } else {
                    DatabaseManager.removeLike(data)
                }
            }
        }
        val forYouList = App.Companion.list.filter {
            it.parentName == getString(R.string.recommend_name)

        }

        recommendedRecycler.run {
            adapter =  SetKeyboardMoreAdapter(
                this@SetKeyboardActivity
            ).apply {
                val shuffled = forYouList[0].keyboardList.shuffled()
                setForYouList(shuffled)
            }.apply {
                setClickAction(object : OnItemClickCallback {
                    override fun OnItemClickListener() {
                        finish()
                    }

                })
            }

            layoutManager = GridLayoutManager(this@SetKeyboardActivity, 2)

        }

    }

    @SuppressLint("CheckResult")
    private fun loadImgGif() {
        Glide.with(this)
            .load(gifUrl)
            .thumbnail(Glide.with(this).load(thumb))
            .addListener(object : RequestListener<Drawable> {
                override fun onLoadFailed(
                    e: GlideException?,
                    model: Any?,
                    target: Target<Drawable>,
                    isFirstResource: Boolean
                ): Boolean {

                    return false
                }

                override fun onResourceReady(
                    resource: Drawable,
                    model: Any,
                    target: Target<Drawable>?,
                    dataSource: DataSource,
                    isFirstResource: Boolean
                ): Boolean {
                    if (resource is WebpDrawable) {
                        resource.loopCount = WebpDrawable.LOOP_FOREVER
                    }

                    return false
                }

            }).into(imgData)
    }

    private fun setApply() {
        applyBtn.setOnClickListener {
            TPAdManager.showTPAD(this@SetKeyboardActivity){
                val checkEnable = Common.checkEnable(this)
                val checkSetDefault = Common.checkSetDefault(this)
                if (!checkEnable || !checkSetDefault) {
                    showDialog()
                    return@showTPAD
                }
                startDown()
            }

        }
    }

    private fun showDialog() {
        dialog = dialog ?: DialogEnableKeyboard.newInstance() .apply{


        }
        dialog?.setClickListener {
            startDown()
        }
        dialog?.show(supportFragmentManager, "")
    }

    private fun startDown() {
        loadingLayout.isVisible = true
        applyBtn.isEnabled = false

        val file = File(unzipPath)
        if (file.exists()) {
            val findFirstDirectory = DealZipFile.findFirstDirectory(file)

            apply("${findFirstDirectory}/")
            applyBtn.isEnabled = true
            loadingLayout.isVisible = false
        } else {
            DealZipFile.startDownloadZip(zipUrl, object :
                SetKeyboardCallback {
                override fun OnApplySkinListener(fileList: List<File?>?) {
                    runOnUiThread {
                        applyBtn.isEnabled = true
                        loadingLayout.isVisible = false
                    }
                    if (fileList.isNullOrEmpty()) {
                        runOnUiThread {
                            Toast.makeText(
                                this@SetKeyboardActivity,
                                getString(R.string.download_fail),
                                Toast.LENGTH_SHORT
                            ).show()
                        }
                    } else {
//                        lifecycleScope.launch {
//                            DbFunction.addDownload(data)
//                        }
                        if (file.exists()) {
                            val findFirstDirectory = DealZipFile.findFirstDirectory(file)
                            Log.d(
                                App.Companion.TAG,
                                "----apply------------it=$findFirstDirectory"
                            )
                            runOnUiThread {
                                apply("${findFirstDirectory}/")

                            }
                        }
                    }


                }

            })
        }

    }

    private fun apply(path: String) {
        var skinParentPath = path
        if (path.contains("res")) {
            skinParentPath = path.substringBeforeLast("res")
        }


        SaveCurrentTheme.updateSkinPath(skinParentPath)
        Toast.makeText(
            this@SetKeyboardActivity,
            getString(R.string.theme_application_successful),
            Toast.LENGTH_SHORT
        ).show()
        startActivity(Intent(this, SuccessPreviewActivity::class.java).apply {
            putExtra(SuccessPreviewActivity.key_name, name)
        })
        finish()
    }




}